/* config.c */

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <ctype.h>
#include "config.h"

#define MAXPATH			1024

char COMMAND[1024] = "tcpsetup", EXTRA[1024] = "";
char MODE[128] = "-deathmatch";
int PORT = 0x869c;
int SKILL = 4;
int EPISODE = 1;
int MISSION = 1;
int TIMER = 0;
char MONSTERS[128] = "";
char NAME[128] = "", EMAIL[128] = "";

Config configs[] = {
	{ "command", CFG_STR, COMMAND },
	{ "extra", CFG_STR, EXTRA },
	{ "mode", CFG_STR, MODE },
	{ "port", CFG_INT, &PORT },
	{ "skill", CFG_INT, &SKILL },
	{ "episode", CFG_INT, &EPISODE },
	{ "mission", CFG_INT, &MISSION },
	{ "timer", CFG_INT, &TIMER },
	{ "monsters", CFG_STR, MONSTERS },
	{ "name", CFG_STR, NAME },
	{ "email", CFG_STR, EMAIL },
};
#define NUMCONFIGS		(sizeof(configs)/sizeof(Config))



int readconfig(fname)
char *fname;
{
	FILE *fp;
	char *home, *comment, path[MAXPATH];
	char line[MAXCFGLINE];
	char line2[MAXCFGLINE];
	char name[MAXCFGLINE];
	char *s;
	int i, k=0;

	strcpy(path, fname);

	if (!(fp = fopen(path, "r"))) return -1;


	while (fgets(line, MAXCFGLINE, fp) != NULL){
		k += strlen(line);
		name[0] = '\0';
		while (isspace(line[strlen(line)-1]))
			line[strlen(line)-1] = '\0';

		while (!((comment=(char *)strstr(line,"#")) &&
			!(comment!=line && (*(comment-1)=='%'))) &&
			line[strlen(line)-1] == '\\'){

			line[strlen(line)-1] = '\0';
			if (fgets(line2, MAXCFGLINE,fp))
				strncat(line, line2, MAXCFGLINE);
		}

		if (comment && !(comment!=line && (*(comment-1)=='%')))
			*comment = '\0';

		sscanf(line," %[_A-Za-z]", name);
		for (i=0; i<NUMCONFIGS; i++){
			if (!strcmp(name, configs[i].cfgname))
				switch (configs[i].cfgtype){
					case CFG_KEY :
						break;
					case CFG_INT :
						sscanf(line," %[_A-Za-z] %d",name,configs[i].cfgvar);
						break;
					case CFG_CHAR :
						sscanf(line," %[_A-Za-z] %c",name,configs[i].cfgvar);
						break;
					case CFG_STR :
						s = line+strlen(name)+1;
						while (isspace(*s)) s++;
						strcpy((char *)configs[i].cfgvar, s);	
						break;
					default:
						break;
				}
		}
	}

	fclose(fp);
	return 0;
}

